import dotenv from 'dotenv';
import { FisMessage } from "../interface/transport.interface";
import { ConnectionAdapter } from "./connector.base";
import { ConnectionState, TransmitterConnectionAdapter as TransmitterConnectionAdapterInterface, Transport, TransportMessage, TransportService } from '../interface/connector.interface';
import { Subject } from 'rxjs';
import { v4 as uuidv4 } from 'uuid'
import { WrappedMessage } from '../utils/message.ordering';

dotenv.config();
/* This transport manager will be instantiating the necessary transport to deal with tranmission and receiving from different receivers
So how?: */
export class TransmitterConnectionAdapter extends ConnectionAdapter implements TransmitterConnectionAdapterInterface {
    connectionStateBus: Subject<ConnectionState> = new Subject()

    constructor(adapterId: string, adapterType: Transport, transportService: TransportService) {
        super()
        // logic here
        this.connector = transportService
        this.setAdapterProfile(adapterId, adapterType)
    }

    emit(message: FisMessage | WrappedMessage): void {
        // logic here
        this.connector.emit({
            id: this.connectorProfile.id,
            transport: this.connectorProfile.transportType,
            target: this.connectorProfile.id, // this should be directed to the channel/client established. Make sure this is right
            payload: message
        } as TransportMessage)
    }

    setAdapterProfile(id: string, adapterType: Transport): void {
        this.connectorProfile = {
            id: id,
            transportType: adapterType
        }
    }

}


