
import { filter, Observable, Observer, Subject, Subscription, takeWhile, Unsubscribable } from 'rxjs';
import { AdapterProfile, AdapterSet, AdaptorTransmissionRole, TransportEvent } from '../interface/connector.interface';
import { Bus, FisMessage, MessageTransmissionBase as MessageTransmissionBaseInterface, TransmissionProfile } from '../interface/transport.interface'
import { v4 as uuidv4 } from 'uuid'
import { ConnectionAdapter } from '../connector/connector.base';

export class MessageTransmissionBase implements MessageTransmissionBaseInterface {
    event!: Observable<TransportEvent>
    msgRepositoryService: any;
    transmissionRole!: AdaptorTransmissionRole;
    adaptorsArray: Array<ConnectionAdapter> = []
    transmissionService: any;
    mainAdapter!: ConnectionAdapter;

    constructor(event: Observable<TransportEvent>) {
        // logic here
    }

    getInfo(): TransmissionProfile {
        throw new Error(`Method not implemented`)
    }

    setUpAdapter(adapter: ConnectionAdapter): void {
        throw new Error(`Method not implemented`)
    }

}